我有两个文件:
文件一:
No ID CV CA1 CA2
1 transcr_10283 0.999023367236861 -0.344113101336184 -0.032235130455987
2 transcr_10371 -0.572755303094372 -0.579145581184253 0.879510598089221
3 transcr_10391 0.999589933675858 -0.379226454955611 -0.302057879326854
4 transcr_10428 0.128862262957329 0.579502720160717 -0.960283285879896
5 transcr_10673 -0.555906836336222 0.996418809959179 0.83927901939441
6 transcr_10719 -0.977601905205625 -0.297994976855801 -0.988480730161833
7 transcr_10805 -0.994387636575223 -0.924363947763111 -0.096820331033279
8 transcr_1084 0.929966893591254 0.994040100421911 0.604483398826667
9 transcr_10892 0.987734223438821 0.822187392097743 0.968727545498998
10 transcr_10892 0.999938729100654 -0.985209499864003 0.958993756142276
文件2:
No ID CV CA1 CA2
1 transcr_8921 0.972442945255909 0.937065785923838 0.999643394568925
2 transcr_10428 0.128862262957329 0.808685528374441 -0.987431892147214
3 transcr_25793 -0.576556453265197 0.956853490465593 -0.712579124289414
4 transcr_1966 0.66610055219078 0.199587132187484 0.47438019134052
5 transcr_10428 -0.770206245250698 -0.434541952574813 0.413082695627957
6 transcr_20649 0.828958672046763 -0.301011711451322 0.85215236415901
7 transcr_11317 0.09699438477018 -0.728279374568874 -0.555587423971877
8 transcr_11317 -0.556544875244594 0.52241898249443 0.361144169769576
9 transcr_7135 0.525796225375268 -0.915309254508446 0.352117890583668
10 transcr_6234 -0.254737326090742 -0.842640701643698 0.435449408114073
我需要一个结果文件,该文件具有使用列file1
(行数较少)与file2
(行数较多)$2
和$3
.所以,我正在寻找这样的东西:
No ID CV CA1 CA2
1 transcr_10283 0.999023367236861 -0.344113101336184 -0.032235130455987
2 transcr_10371 -0.572755303094372 -0.579145581184253 0.879510598089221
3 transcr_10391 0.999589933675858 -0.379226454955611 -0.302057879326854
5 transcr_10673 -0.555906836336222 0.996418809959179 0.83927901939441
6 transcr_10719 -0.977601905205625 -0.297994976855801 -0.988480730161833
7 transcr_10805 -0.994387636575223 -0.924363947763111 -0.096820331033279
8 transcr_1084 0.929966893591254 0.994040100421911 0.604483398826667
9 transcr_10892 0.987734223438821 0.822187392097743 0.968727545498998
10 transcr_10892 0.999938729100654 -0.985209499864003 0.958993756142276
File2 未排序,我正在寻找一种无需对文件进行排序的方法。
谢谢!
编辑:为了使其更容易被看到,transcr_10428 0.128862262957329
在本例中, 的行被删除了。
答案1
和awk
:
$ awk -v FS="\t" -v OFS="\t" 'NR==FNR {trans[$2"|"$3]++; next;} FNR==1 {print} FNR>1 {if(!trans[$2"|"$3]) print}' file2 file1
- 首先
file2
读入,并使用第 2 列和第 3 列的值将其作为键存储在列表中。 - 如果
file1
读入,则打印标题行。对于下一行,我们检查之前创建的列表中是否存在具有第 2 列和第 3 列值的键。如果没有,我们打印出该行。
答案2
文件比较的方式没有明确解释/定义。
然而,这并不妨碍我尝试读懂你的想法......
据我了解,文件2是一种数据库文件或参考。文件 1 据称包含新数据。
我理解的“比较”:如果文件 1 的第 2 或第 3 列的值已在文件 2(即引用)中找到,则不要打印/包含它。否则打印/包含它。
好消息是,它确实不需要排序......正如您所要求的那样......。
下面是一个带有 2 个参数的脚本:第一个是新的数据文件(示例中的文件 1)。第二个是数据库文件(示例中的文件 2)。
#!/bin/bash
new_file=$1
db_file=$2
# Just checking the last parameter
if [ "x" = "x$db_file" ]; then
echo >&2 "[ERROR] This scripts expect 2 file path as parameter."
exit 1
fi
if [ ! -f $new_file ]; then
echo >&2 "[ERROR] First parameter file doesn't exist."
exit 2
fi
if [ ! -f $db_file ]; then
echo >&2 "[ERROR] First parameter file doesn't exist."
exit 3
fi
declare -A data_base
# Open both files and assign to file descriptor 10 and 11
exec 10< $new_file
exec 11< $db_file
# Step 1
# Building map of base data first (for the comparison to happen in next step)
first_line=1
while [ /bin/true ];
do
read -u 11 db_file_col1 db_file_col2 db_file_col3 db_file_rest || {
break;
}
# Skipping the header so that it will appear in the diff as shown in the example
if [ $first_line -ne 0 ]; then
first_line=0
continue
fi
# Creating map from Col 2 and Col 3 (keys) to the whole line (value)
data_base[$db_file_col2]="$db_file_col1 $db_file_col2 $db_file_col3 $db_file_rest"
data_base[$db_file_col3]="$db_file_col1 $db_file_col2 $db_file_col3 $db_file_rest"
done
# Step 2
# Actual comparison ...
while [ /bin/true ];
do
read -u 10 new_file_col1 new_file_col2 new_file_col3 new_file_rest || {
break;
}
if [ -z "${data_base[$new_file_col2]}" ] && [ -z "${data_base[$new_file_col3]}" ]; then
echo "$new_file_col1 $new_file_col2 $new_file_col3 $new_file_rest"
fi
done
例如,如果将脚本保存到名为 process.sh 的文件中(然后使用“chmod 755 process.sh”使其可执行),则执行:
./process.sh file1 file2
同时导致您确切的预期输出/结果。
注意:此脚本将文件 2 的内容至少两倍保存到内存中。确保你有足够的内存....